# <in.H  Twod > out.H
#
#  Pass a 2-D signal thru streaming decon
#  
# keyword streaming 2-D decon
# JFC 
#%
integer n1, n2, n3, na1, na2, nb1, nb2, esize
from history:	integer n1, n2, esize
from param:     integer na1=5, na2=2, nb1=10, nb2=5
			n3=1
to history:     integer n3
if (esize !=4)	call erexit('esize != 4')
allocate:	real dd(n1,n2),   rr(n1,n2)
allocate:	real aa(na1,na2), da(na1,na2)
allocate:	real rb(nb1,nb2), dr(nb1,nb2)

subroutine dumb( n1,n2,n3, na1,na2, nb1,nb2, dd,     rr,     rb,     dr,     aa,     da   )
real alpha, top, bot, weight
real dd(n1 ,n2 ), rr(n1, n2 )
real aa(na1,na2), da(na1,na2)
real rb(nb1,nb2), dr(nb1,nb2)
integer  n1, n2, n3, na1, na2, nb1, nb2
integer ir1,ir2,     ia1, ia2, ib1, ib2, i, lag
integer	iter, niter, nbmax1, nbmax2
from param:     integer niter=2
call hclose()	# no more putch
call sreed(  'in', dd, 4*n1*n2)
do ia1=1,na1 {
do ia2=1,na2 {
	aa(ia1,ia2) = 0.
	}}
do ia1= 1,  na1/2 {
	aa( ia1     ,1) = 0.
	}
	   lag = (na1+1)/2
        aa(lag,1) = 1.		# Put spike on side of filter.

do ir2 = 1, n2 {
do ir1 = lag, n1 {
	do iter=1,niter	{
		do ib1=1, nb1{
		do ib2=1, nb2{
			rb(ib1,ib2) = 0.
			}}
		do ib1=1, min0( nb1, ir1) {
		do ib2=1, min0( nb2, ir2) {
			do ia1 = 1, min0( na1, ir1-ib1+1) {
			do ia2 = 1, min0( na2, ir2-ib2+1) {
				rb(ib1,ib2) += dd(ir1-ib1-ia1+2,ir2-ib2-ia2+2) * aa(ia1,ia2)
				} }
			} }
		rr(ir1-lag+1,ir2) = rb(1,1)    # Here goes the output.
		do ia1=1, na1 {
		do ia2=1, na2 {
			da(ia1,ia2) = 0.
			}}
		do ib1 = 1, min0( nb1, ir1) {
		do ib2 = 1, min0( nb2, ir2) {
			do ia1 = 1, min0( na1, ir1-ib1+1 ) {
			do ia2 = 1, min0( na2, ir2-ib2+1 ) {
				da(ia1,ia2) += dd( ir1-ib1-ia1 +2, ir2-ib2-ia2 +2) * rb(ib1,ib2)
				}} 
			}}				
		do ia1= 1, lag {
			da( ia1 ,1) = 0.		# Constrain the 1.0 and the 0.0s
			}
		do ib1= 1, nb1 {
		do ib2= 1, nb2 {
			dr(ib1,ib2) = 0.
			}}
		do ib1 = 1, min0( nb1, ir1) {
		do ib2 = 1, min0( nb2, ir2) {
			do ia1 = 1, min0( na1, ir1-ib1+1 ) {
			do ia2 = 1, min0( na2, ir2-ib2+1 ) {
				dr(ib1,ib2) += dd( ir1-ib1-ia1 +2, ir2-ib2-ia2 +2) * da(ia1,ia2)
				}}
			}}				
#		nbmax = min0(nb,ir-na)		# Ignoring this optional boundary condition.
		nbmax1 = nb1
		nbmax2 = nb2
		top=0.;  bot=1.e-20
		do ib1 = 1, nbmax1 {
		do ib2 = 1, nbmax2 {
			weight = sqrt( (nb1-ib1+1.)**2 + (nb2-ib2+1.)**2 )       # XXX optional
			weight = 1.
			top += rb(ib1,ib2) * dr(ib1,ib2) * weight
			bot += dr(ib1,ib2) * dr(ib1,ib2) * weight
			}}
		alpha = - top/bot
		do ia1 = 1, na1 {
		do ia2 = 1, na2 {
			aa(ia1,ia2) += alpha * da(ia1,ia2)
			}}
		}
	}}
#call srite( 'out', dd, 4*n1*n2)
call srite( 'out', rr, 4*n1*n2)					# XXX
return;	end

